#!/bin/bash
#  wls startup script for Weblogic {{ wl_version.base_version }}
#
# chkconfig: - 76 13
# description: weblogic
# processname: wls{{ wl_version.base_version }}

# LSB compliant service control script
#
### BEGIN INIT INFO
# Provides:                     wls{{ wl_version.base_version }}
# Required-Start:               $ALL
# Should-Start:
# Required-Stop:                $ALL
# Should-Stop:
# Default-Start:                3 5
# Default-Stop:                 0 1 6
# Short-Description:            wls{{ wl_version.base_version }}
# Description:                  Starts and stops wls
### END INIT INFO

### Rev8
# Added support for Fusion MiddleWare
# Added domain name specification
# Added option to prevent process killing
# Added stop timeouts
# Added lock files cleanup
# Lock file for status has been removed
# MW_HOME autodetect has been added
# DOMAIN_NAME autodetect has been added
# Bug fix (script's arguments)

### Rev9
# Added Managed Servers parallel start
# Bug fix (some messages)

### Rev10
# Added option to either stop or not Managed servers during system reboot
# Shutdown during OS shutdown fixed
# Fixed Application status for Clustered applications

### Rev11
# AIX bug fix

### Rev12
# Multiply Oracle Home environment support

### Rev13
# Automatic names generation for password files

### Rev14
# Automatic names generation for python scripts

### Rev15
# username prefix added to lock files
# Solaris support added

### Rev16
# Check for Log folder (Not created by default in WLS12.2)

### Rev17
# Weblogic 11 support
# Scripts moved to a separate folder
# Status splitted into two functions

### Rev18
# Weblogic 12.2 support

### Rev19
# Current version

### Rev20
# Linux sudo support for VIP added

### Rev21
# Zabbix support

### Rev22
# MW_HOME detection improvements
# SLES support added (LINUX_RELEASE)

### Rev23
# Debug added
# MW_HOME detection improvements

### Rev24
# Dont start if domain name cant be determined

### Rev25
# Solaris bug fixes

### Rev26
# partial_stop function bugfix

### Rev27
# support wls 12.2.1.4

### Rev28
# Fixed scripts folder creation
# fixed linux release check

### Rev28
# Veritas Cluster support added. See status exit code

### Rev29
# Weblogic 14 support added

### Rev30
#Append added to startup logs
#Scripts timeouts changed for 5 minutes

### Rev31
#Debug options added
#Bugs fixing

########################################
#  BEGIN OF THE CONFIGURATION SECTION  #
########################################

#Specify Weblogic version
# 11    - WebLogic Server 11g (10.3.x)
# 12    - WebLogic Server 12c (12.1.x)
# 122   - WebLogic Server 12c (12.2.1.3)
# 124   - WebLogic Server 12c (12.2.1.4)
# 141   - Weblogic Server 14c (14.1.1.x)
WLS_VERSION={{ wl_version.version }}

#Specify folder to store scripts inside user's home folder
#If not specified, default value will be used
SCRIPTS_FOLDER=""

if [ "${SCRIPTS_FOLDER}x" == "x" ]
    then
        case $WLS_VERSION in
            11)
                SCRIPTS_FOLDER=scripts11
                ;;
            12)
                SCRIPTS_FOLDER=scripts12
                ;;
            122|124)
                SCRIPTS_FOLDER=scripts122
                ;;
            141|142)
                SCRIPTS_FOLDER=scripts14
                ;;
            *)
                SCRIPTS_FOLDER=scripts122
                ;;
            esac
fi

WLS_USER={{ wl_user }}

WLS_NAME="weblogic.Server"
NM_NAME="NodeManager"

#Specify t3 protocol connection timeout in milliseconds
T3_TIMEOUT=60000

#Specify AdminServer port
ADMIN_PORT={{ weblogic_admin_port_default }}

#Specify AdminServer Hostname or IP to use to connect to AdminServer
#Or leave it blank to use localhost (default)
#ADMIN_HOST=wls-server.local
ADMIN_HOST=

#If more than one domain runs on the same server set CHECK_AFTER_STOP to NO
CHECK_AFTER_STOP=YES

#Do we need to stop Managed Servers during shutdown?
SHUT_MS="TRUE"

#Specify domain name or leave it blank for autodetect
MY_DOMAIN_NAME={{ domain.domain_name }}

#--------------------------------------------
case $WLS_VERSION in
    11)
        USER_CONF_FILE_MASK=configfile.secure11
        USER_KEY_FILE_MASK=keyfile.secure11
    ;;
    12)
        USER_CONF_FILE_MASK=configfile.secure12
        USER_KEY_FILE_MASK=keyfile.secure12
    ;;
    122|124)
        USER_CONF_FILE_MASK=configfile.secure122
        USER_KEY_FILE_MASK=keyfile.secure122
    ;;
    141|142)
        USER_CONF_FILE_MASK=configfile.secure14
        USER_KEY_FILE_MASK=keyfile.secure14
    ;;
    *)
        USER_CONF_FILE_MASK=configfile.secure12
        USER_KEY_FILE_MASK=keyfile.secure12
    ;;
esac


#--------------------------------------------
#Do we need to add VIP (Virtual IP) address first?
USE_VIP=NO
VIP_ADDR=192.168.21.94
VIP_MASK=25
VIP_DEV=eth0
GW_IP=192.168.21.1

#-------------------------------------------
#If running in Cluster environment set USE_CLUSER variable to TRUE otherwise set it to FALSE.
USE_CLUSTER="{{ weblogic_use_cluster }}"

#-------------------------------------------
HOME_FOLDER=`grep "^${WLS_USER}:" /etc/passwd | cut -d ':' -f 6`
#Specify Middle Ware Home or leave it blank for autodetect
MY_MW_HOME_TO_USE={{ wl_version.wl_oracle_home }}

#-------------------------------------------
#Specify timeout for stop procedures
#it can be NUMBER[SUFFIX] s for second, m for minute, h for hour
STOP_TIMEOUT=5m

#-------------------------------------------
#Managed server parallel start
MNG_PARALLEL="{% if instance in ('tst', 'dev') %}TRUE{% else %}FALSE{% endif %}"

#-------------------------------------------
#Shutdown Message
SHUT_MSG="weblogic shutdown succeeded"

#-------------------------------------------
#Status options
#Do we need to check Managed Servers status
CHECK_SRV="YES"

#Do we need to check Applications status
CHECK_APP="YES"

#-------------------------------------------
#Zabbix options
PREFIX=XXXaaa

#Linux release file location
LINUX_RELEASE_FILE=/etc/redhat-release

#-------------------------------------------
#Debug options
DEBUG_ENABLED="TRUE"
DEBUG_FILE_NAME=wls_debug.log

###Debug info to console
#0 - Disabled
#1 - Enabled
KI_VERBOSE=1

### Additional debug data to console
#0 - Disabled
#1 - Enabled
KI_QUIET=1

#-----------------------------------------
MNG_SRV_STATUS_BASE=/tmp/wls_mng_srv_status
APP_STATUS_BASE=/tmp/wls_app_status

######################################
#  END OF THE CONFIGURATION SECTION  #
######################################


#Debug file location.
if [ "$USER" == "" ] || [ "$USER" == "root" ]
        then
                DEBUG_FILE=/var/log/${DEBUG_FILE_NAME}
        else
                DEBUG_FILE=${HOME_FOLDER}/${DEBUG_FILE_NAME}
fi

#Redirect output for debugging

if [ $DEBUG_ENABLED == "TRUE" ]
    then
        DEBUG_REDIRECT=">> ${DEBUG_FILE} 2>&1"
fi

log()
{
    echo `date '+%F %H:%M:%S'` `hostname` "$LOGNAME: $*" >> "$DEBUG_FILE"
}

msg()
{
    if [ $DEBUG_ENABLED == "TRUE" ]
        then
            log "$*"
            [ $KI_VERBOSE -ne 0 -a $KI_QUIET -eq 0 ] && echo "$*"
            [ $KI_VERBOSE -ne 0 -a $KI_QUIET -ne 0 ] && echo `date '+%F %H:%M:%S'` `basename $0`": $*"
    fi
}

wrap_exec()
{
    if [ $DEBUG_ENABLED == "TRUE" ]
        then
            log "--- Executing $* ---"
                if [ $KI_VERBOSE -ne 0 ]
                    then
                        $* | tee -a "$DEBUG_FILE"
                    else
                        $* >> "$DEBUG_FILE"
                fi
            log "--- Exit of $* ---"
    fi
}



create_lock_file() {

if [ "$USE_CLUSTER" == "FALSE" ]

        then

        #Create lock file to exclude multiple instances of the script
        if [ -e $LOCK_FILE ]
                then
                        echo "Another instance of the script running... Or check for lock file: $LOCK_FILE"
                        exit 255
        fi

        touch $LOCK_FILE

        else
                echo ""
                echo "Assuming using script in the Cluster Environment"
                echo "Multiply instances of script is permitted. Cluster must take care about it"
                echo ""
fi
}

remove_lock_file() {
if [ "$USE_CLUSTER" == "FALSE" ]
        then
                rm -f $LOCK_FILE
fi
}

if [ -e ${HOME_FOLDER}/.profile ]
    then
        . ${HOME_FOLDER}/.profile
        USER_PROFILE=${HOME_FOLDER}/.profile
    else
        . ${HOME_FOLDER}/.bash_profile
        USER_PROFILE=${HOME_FOLDER}/.bash_profile
fi

case $WLS_VERSION in
        11)
        if [ ${MY_MW_HOME_TO_USE}x == "x" ]
            then
                echo "MY_MW_HOME_TO_USE hasnt been specified. Trying to detect it..."
                MY_MW_HOME=`cat ${HOME_FOLDER}/bea/beahomelist`
                echo "MW_HOME: $MY_MW_HOME"
            else
                MY_MW_HOME=$MY_MW_HOME_TO_USE
        fi

        MY_WL_HOME=${MY_MW_HOME}/wlserver_10.3
        ;;

        12|122|124|141|142)
        if [ ${MY_MW_HOME_TO_USE}x == "x" ]
            then
                echo "MY_MW_HOME_TO_USE hasnt been specified. Trying to detect it..."
                FIND_DIRECTORIES=`ls -ld /* | awk '{print $3" "$9}' | grep "^${WLS_USER}" | awk '{print $2}'`

                debug_print "FIND_DIRECTORIES 1st iteration from find command: $FIND_DIRECTORIES"

                FIND_DIRECTORIES="$FIND_DIRECTORIES $HOME_FOLDER"
                debug_print "FIND_DIRECTORIES 2nd iteration adding home folder: $FIND_DIRECTORIES"

                INVENTORY_FOLDER=`find $FIND_DIRECTORIES -type d -name oraInventory 2>/dev/null`
                debug_print "INVENTORY_FOLDER: $INVENTORY_FOLDER"

                if [ "${INVENTORY_FOLDER}x" == "x" ]
                    then
                        #Directories by secondary groups
                        SECOND_GROUPS=`grep ":*${WLS_USER}*\$" /etc/group | grep -v "^${WLS_USER}" | cut -d ':' -f 1`
                        for group_name in $SECOND_GROUPS
                            do
                                FIND_DIRECTORIES=$FIND_DIRECTORIES
                                FIND_DIRECTORIES_TMP1=`ls -ld /* | awk '{print $4" "$9}' | grep "^${group_name}" | awk '{print $2}'`
                                FIND_DIRECTORIES_TMP2=`ls -ld /home/* | awk '{print $4" "$9}' | grep "^${group_name}" | awk '{print $2}'`
                                FIND_DIRECTORIES_TMP3=`ls -ld /export/home/* | awk '{print $4" "$9}' | grep "^${group_name}" | awk '{print $2}'`
                                FIND_DIRECTORIES="${FIND_DIRECTORIES_TMP1} ${FIND_DIRECTORIES_TMP2} ${FIND_DIRECTORIES_TMP3}"
                                echo "FIND_DIRECTORIES: $FIND_DIRECTORIES"
                            done
                        INVENTORY_FOLDER=`find $FIND_DIRECTORIES -type d -name oraInventory 2>/dev/null`
                fi

                MY_MW_HOME=`grep "<HOME NAME=.*OracleHome.* LOC=" ${INVENTORY_FOLDER}/ContentsXML/inventory.xml | cut -d '=' -f 3 | cut -d "\"" -f 2`

                #check MY_MW_HOME ownship

                for my_mw_home_dir_name in $MY_MW_HOME
                    do
                        ls -ld $my_mw_home_dir_name | awk '{print $3}' | grep "$WLS_USER" >/dev/null 2>&1
                        if [ $? -eq 0 ]
                            then
                                MY_MW_HOME=$my_mw_home_dir_name
                        fi

                    done

                echo "MW_HOME: $MY_MW_HOME"
            else
                MY_MW_HOME=$MY_MW_HOME_TO_USE
        fi

        MY_WL_HOME=${MY_MW_HOME}/wlserver

    ;;

    *)
        echo "Can't determine weblogic version. Please set WLS_VERSION configuration parameter"
    ;;
esac

if [ "${MY_DOMAIN_NAME}x" == "x" ]
    then
        msg "Domain name was not specified, taking it from registry"
        #DOMAIN=`ls ${MY_MW_HOME}/user_projects/domains`
        if [ -e ${MY_MW_HOME}/domain-registry.xml ]
            then
                msg "grepping domain location from ${MY_MW_HOME}/domain-registry.xml"
                DOMAIN_LOCATION=`grep "domain location"  ${MY_MW_HOME}/domain-registry.xml  | cut -d "\"" -f 2 | head -1`
                msg "Domain location: $DOMAIN_LOCATION"

                MY_DOMAIN_NAME=`basename $DOMAIN_LOCATION`
                FOLDER=$DOMAIN_LOCATION
                msg "setting START_ALLOWED to TRUE"
                START_ALLOWED="TRUE"
            else
                msg "file ${MY_MW_HOME}/domain-registry.xml does not exist"
                msg "setting START_ALLOWED to FALSE"
                START_ALLOWED="FALSE"
                echo "Cant find domain location, cant proceed"
                msg "Cant find domain location, cant proceed"
        fi
    else
        FOLDER=${MY_MW_HOME}/user_projects/domains/${MY_DOMAIN_NAME}
        msg "FOLDER: $FOLDER"
        msg "setting START_ALLOWED to TRUE"
        START_ALLOWED="TRUE"
fi


case $WLS_VERSION in
    11|12)
        WLST=${MY_WL_HOME}/common/bin/wlst.sh
        ;;
    122|124|141|142)
        WLST=${MY_MW_HOME}/oracle_common/common/bin/wlst.sh
        ;;
    *)
        WLST=${MY_WL_HOME}/common/bin/wlst.sh
        ;;
esac

LOG_FOLDER=${MY_MW_HOME}/logs
WLS_LOCK_FILES="${FOLDER}/servers/*/tmp/*.lok"

#--------------------------------------------
#Generate names for log files
DATE_STR=$(date +"%Y%m%d%H%M%S")
LOG_FILE=wls_${MY_DOMAIN_NAME}_${DATE_STR}.log
LOG_FILE_NM=node_manager_${MY_DOMAIN_NAME}.log

#-------------------------------------------
#Generate name lock file
case $WLS_VERSION in
    11)
        LOCK_FILE=/tmp/svweb11_${WLS_USER}_${MY_DOMAIN_NAME}_lock
        ;;
    12)
        LOCK_FILE=/tmp/svweb12_${WLS_USER}_${MY_DOMAIN_NAME}_lock
        ;;
    122|124)
        LOCK_FILE=/tmp/svweb122_${WLS_USER}_${MY_DOMAIN_NAME}_lock
        ;;
    141|142)
        LOCK_FILE=/tmp/svweb14_${WLS_USER}_${MY_DOMAIN_NAME}_lock
        ;;
    *)
        LOCK_FILE=/tmp/svweb12_${WLS_USER}_${MY_DOMAIN_NAME}_lock
        ;;
esac

#-------------------------------------------
#Generate names for password files
USER_CONF_FILE=${MY_DOMAIN_NAME}.${USER_CONF_FILE_MASK}
USER_KEY_FILE=${MY_DOMAIN_NAME}.${USER_KEY_FILE_MASK}

if [ "${ADMIN_HOST}x" == "x" ]
    then
        ADMIN_HOST=localhost
fi

#Check for Credential files

if [ ! -e ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE} ] || [ ! -e ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE} ]
    then
        echo "
            To use this script please create credential files for Weblogic.

            Make all steps as $WLS_USER OS user
            1. ${MY_MW_HOME}/oracle_common/common/bin/wlst.sh
            2. wls:/offline> connect('weblogic', '<<weblogic_password>>', '127.0.0.1:${ADMIN_PORT}')
            3. wls:/base_domain/serverConfig> storeUserConfig('${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE}', '${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE}')
            4. wls:/base_domain/serverConfig> exit()

            For more information see:
            http://docs.oracle.com/cd/E28280_01/web.1111/e13715/using_wlst.htm#WLSTG129
        "
    #exit 255
fi

#Check for Log folder (Not created by default in WLS12.2)

if [[ ! -d $LOG_FOLDER  ]]
        then
                echo "
                        Log directory $LOG_FOLDER does not exist. Creating...
                "
                case "$USER" in

                        root)
                                su - $WLS_USER -c "mkdir ${LOG_FOLDER}"
                        ;;
                        $WLS_USER)
                                mkdir ${LOG_FOLDER}
                        ;;
                        *)
                                su - $WLS_USER -c "mkdir ${LOG_FOLDER}"
                        ;;
                esac
fi

if [[ ! -d ${HOME_FOLDER}/$SCRIPTS_FOLDER  ]]
        then
                echo "
                        Scripts directory $SCRIPTS_FOLDER does not exist. Creating...
                "
                case "$USER" in

                        root)
                                su - $WLS_USER -c "mkdir ${HOME_FOLDER}/${SCRIPTS_FOLDER}"
                        ;;
                        $WLS_USER)
                                mkdir ${HOME_FOLDER}/${SCRIPTS_FOLDER}
                        ;;
                        *)
                                su - $WLS_USER -c "mkdir ${HOME_FOLDER}/${SCRIPTS_FOLDER}"
                        ;;
                esac
fi


UNAME=`uname`

case "$UNAME" in

    AIX)
            PCMD="ps -f -u $WLS_USER | grep $WLS_NAME | grep -v grep | awk '{print \$2}'"
        PCMD_NM="ps -f -u $WLS_USER | grep $NM_NAME | grep $MY_DOMAIN_NAME | grep -v grep | awk '{print \$2}'"
        PCMD_KILL="ps -f -u $WLS_USER | grep -v grep | awk '{print \$2}'"
        SHUT_LOG_CMD="/usr/bin/logger -t wls${WLS_VERSION} '${SHUT_MSG}'"
    ;;

    Linux)
            PCMD="pgrep -u $WLS_USER -f $WLS_NAME"
        #PCMD_NM="pgrep -u $WLS_USER -f $NM_NAME"
        #LINUX_RELEASE=`cat /etc/redhat-release | awk '{print $7}' | cut -d. -f1`
        if [ -e $LINUX_RELEASE_FILE ]
            then
                LINUX_RELEASE=`cat $LINUX_RELEASE_FILE | grep -oP "release \K[[:digit:]](?=\.[[:digit:]])"`
            else
                LINUX_RELEASE=0
        fi

        case $WLS_VERSION in
            12|122|124|141|142)
                PCMD_NM="pgrep -u $WLS_USER -f 'RootDirectory=.+$MY_DOMAIN_NAME.+$NM_NAME'"
            ;;
            11)
                PCMD_NM="pgrep -u $WLS_USER -f 'bea.home=$MY_MW_HOME .+NodeManager'"
            ;;
            *)
            ;;
        esac

        ADD_VIP="ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
        DEL_VIP="ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"

        PING_GW="ping -c 2 -I $VIP_ADDR $GW_IP"
        PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"

        TIMEOUT_CMD=/usr/bin/timeout
        SHUT_LOG_CMD="/usr/bin/logger -t wls${WLS_VERSION} '${SHUT_MSG}'"
        ;;

    SunOS)
        USER_ID=`grep "^${WLS_USER}:" /etc/passwd | cut -d : -f 3`
        if [ `uname -r` == "5.11" ]
        then
            PCMD="ps auxww -n | grep $USER_ID | grep $WLS_NAME | grep -v grep | awk '{print \$2}'"
            PCMD_NM="ps auxww -n | grep $USER_ID | grep $NM_NAME | grep $MY_DOMAIN_NAME | grep -v grep | awk '{print \$2}'"
        else
            if [ -e /usr/ucb/ps ]
                then
                    PCMD="/usr/ucb/ps -axww | grep $WLS_USER | grep $WLS_NAME | grep -v grep | awk '{print \$1}'"
                    PCMD_NM="/usr/ucb/ps -axww | grep $WLS_USER | grep $NM_NAME | grep $MY_DOMAIN_NAME | grep -v grep | awk '{print \$2}'"
                else
                    PCMD="ps -f -u $WLS_USER | grep java | grep -v grep | awk '{print \$2}'"
                    PCMD_NM="ps -f -u $WLS_USER | grep java | grep -v grep | awk '{print \$2}'"
            fi
        fi

        TIMEOUT_CMD=/usr/bin/timeout
        ;;
esac


case "$USER" in

        root)
                    START_CMD="su - $WLS_USER -c \"nohup ${FOLDER}/startWebLogic.sh > ${LOG_FOLDER}/${LOG_FILE} 2>&1 &\""

            case $WLS_VERSION in

                11)
                    START_CMD2="su - $WLS_USER -c \"nohup ${MY_WL_HOME}/server/bin/startNodeManager.sh >> ${LOG_FOLDER}/${LOG_FILE_NM} 2>&1 &\""
                ;;

                12|122|124|141|142)
                            START_CMD2="su - $WLS_USER -c \"nohup ${FOLDER}/bin/startNodeManager.sh >> ${LOG_FOLDER}/${LOG_FILE_NM} 2>&1 &\""
                ;;
                *)
                ;;
            esac

                    START_CMD3="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.startManagedServersMany.py $DEBUG_REDIRECT\""

                    STOP_CMD1="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.stopManagedServersMany.py $DEBUG_REDIRECT\""
                    STOP_CMD2="${PCMD_NM} | xargs kill"
                    STOP_CMD3="su - $WLS_USER -c \"${FOLDER}/bin/stopWebLogic.sh \""
                    STOP_CMD4="${PCMD} | xargs kill -9"

                    STATUS_APP_CMD="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusApp.py | grep 'Status -> OK' > /dev/null 2>&1\""
                    STATUS_APP_CMD_ZBX="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusApp.py\""
                    STATUS_SRV_CMD="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusManagedServers.py | grep 'Status -> OK'  > /dev/null 2>&1\""

                    RESET_DS_CMD="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.resetDS.py\""

        ;;

        $WLS_USER)
                    START_CMD="nohup ${FOLDER}/startWebLogic.sh > ${LOG_FOLDER}/${LOG_FILE} 2>&1 &"
            ROTATE_CMD="mv ${LOG_FOLDER}/${LOG_FILE} ${LOG_FOLDER}/${LOG_FILE}_`date +%Y%m%d_%H%M%S`"
			MNG_SRV_STATUS_FILE=${MNG_SRV_STATUS_BASE}_${WLS_USER}_${MY_DOMAIN_NAME}
			APP_STATUS_FILE=${APP_STATUS_BASE}_${WLS_USER}_${MY_DOMAIN_NAME}

            case $WLS_VERSION in
                12|122|124|141|142)
                    START_CMD2="nohup ${FOLDER}/bin/startNodeManager.sh >> ${LOG_FOLDER}/${LOG_FILE_NM} 2>&1 &"
                    ;;
                11)
                    START_CMD2="nohup ${MY_WL_HOME}/server/bin/startNodeManager.sh >> ${LOG_FOLDER}/${LOG_FILE_NM} 2>&1 &"
                    ;;
                *)
                ;;
                esac
                    START_CMD3="$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.startManagedServersMany.py"

                    STOP_CMD1="$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.stopManagedServersMany.py"
                    STOP_CMD2="${PCMD_NM} | xargs kill"
                    STOP_CMD3="${FOLDER}/bin/stopWebLogic.sh "
                    STOP_CMD4="${PCMD} | xargs kill -9"

                    STATUS_APP_CMD="$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusApp.py | grep 'Status -> OK' > /dev/null 2>&1"
                    STATUS_SRV_CMD="$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusManagedServers.py | grep 'Status -> OK'  > /dev/null 2>&1"

                    RESET_DS_CMD="$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.resetDS.py"

                ADD_VIP="sudo "${ADD_VIP}
                DEL_VIP="sudo "${DEL_VIP}

        ;;

        *)

        START_CMD="su - $WLS_USER -c \"nohup ${FOLDER}/startWebLogic.sh > ${LOG_FOLDER}/${LOG_FILE} 2>&1 &\""
        START_CMD2="su - $WLS_USER -c \"nohup ${FOLDER}/bin/startNodeManager.sh >> ${LOG_FOLDER}/${LOG_FILE_NM} 2>&1 &\""
        #START_CMD2="su - $WLS_USER -c \"nohup ${MY_WL_HOME}/server/bin/startNodeManager.sh >> ${LOG_FOLDER}/${LOG_FILE_NM} 2>&1 &\""
        START_CMD3="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.startManagedServersMany.py\""

        STOP_CMD1="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.stopManagedServersMany.py\""
        STOP_CMD2="${PCMD_NM} | xargs kill"
        STOP_CMD3="su - $WLS_USER -c \"${FOLDER}/bin/stopWebLogic.sh \""
        STOP_CMD4="${PCMD} | xargs kill -9"

        STATUS_APP_CMD="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusApp.py | grep 'Status -> OK' > /dev/null 2>&1\""
        STATUS_SRV_CMD="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusManagedServers.py | grep 'Status -> OK'  > /dev/null 2>&1\""

        RESET_DS_CMD="su - $WLS_USER -c \"$WLST ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.resetDS.py\""
    ROTATE_CMD="su - $WLS_USER -c \"mv ${LOG_FOLDER}/${LOG_FILE} ${LOG_FOLDER}/${LOG_FILE}_`date +%Y%m%d_%H%M%S`\""
	MNG_SRV_STATUS_FILE=${MNG_SRV_STATUS_BASE}_root_${MY_DOMAIN_NAME}
	APP_STATUS_FILE=${APP_STATUS_BASE}_root_${MY_DOMAIN_NAME}


        ;;

esac

log()
{
    echo `date '+%F %H:%M:%S'` `hostname` "$LOGNAME: $*" >> "$DEBUG_FILE"
}

msg()
{
    if [ $DEBUG_ENABLED == "TRUE" ]
        then
            log "$*"
            [ $KI_VERBOSE -ne 0 -a $KI_QUIET -eq 0 ] && echo "$*"
            [ $KI_VERBOSE -ne 0 -a $KI_QUIET -ne 0 ] && echo `date '+%F %H:%M:%S'` `basename $0`": $*"
    fi
}

wrap_exec()
{
    if [ $DEBUG_ENABLED == "TRUE" ]
        then
            log "--- Executing $* ---"
                if [ $KI_VERBOSE -ne 0 ]
                    then
                        $* | tee -a "$DEBUG_FILE"
                    else
                        $* >> "$DEBUG_FILE"
                fi
            log "--- Exit of $* ---"
    fi
}

function start
{
    if [ "$START_ALLOWED" == "TRUE" ]
        then

            echo "Removing lock files..."
            msg "Removing lock files: $WLS_LOCK_FILES"
            rm -rf $WLS_LOCK_FILES

            msg "starting AdminServer"
		msg "Rotating the log file"

		wrap_exec "mv ${LOG_FOLDER}/${LOG_FILE} ${LOG_FOLDER}/${LOG_FILE}_`date +%Y%m%d_%H%M%S`"

            msg "Executing $START_CMD"
		START_CMD_TIME_COUNTER_START=`date +%s`

                eval $START_CMD $DEBUG_REDIRECT

                START_CMD_STAT=$?
                msg "START_CMD_STAT: $START_CMD_STAT"
            msg "Starting Nodemanager"
            msg "Executing $START_CMD2"
		START_CMD2_TIME_COUNTER_START=`date +%s`

                eval $START_CMD2 $DEBUG_REDIRECT

                START_CMD2_STAT=$?
		START_CMD2_TIME_COUNTER_FINISH=`date +%s`
		START_CMD2_TIME_ELAPSED=`echo "$START_CMD2_TIME_COUNTER_FINISH - $START_CMD2_TIME_COUNTER_START" | bc`
		msg "START_CMD2_STAT: $START_CMD2_STAT, time elapsed: $START_CMD2_TIME_ELAPSED sec"
		msg "Wait for Adminserver startup"

                ADM=`netstat -an | grep $ADMIN_PORT | grep 127.0.0.1 | grep LISTEN | wc -l`
            msg "ADM: $ADM"
                while [ $ADM -eq 0 ]
                        do
                msg "In the LOOP for ADM variable"
                        sleep 1
                        ADM=`netstat -an | grep $ADMIN_PORT | grep 127.0.0.1 | grep LISTEN | wc -l`
                        grep FORCE_SHUTTING_DOWN ${LOG_FOLDER}/${LOG_FILE}
                        if [ $? -eq 0 ]
                                then
                        echo "Startup failed. Stopping everything started."
                        echo "Check log file: ${LOG_FOLDER}/${LOG_FILE}"
                        partial_stop
                        remove_vip_addr
                        exit 255
                        fi
                done

		START_CMD_TIME_COUNTER_FINISH=`date +%s`
		START_CMD_TIME_ELAPSED=`echo "$START_CMD_TIME_COUNTER_FINISH - $START_CMD_TIME_COUNTER_START" | bc`
                msg "AdminServer is started, time elapsed: $START_CMD_TIME_ELAPSED sec"
                echo "Starting Managed Servers"

                eval $START_CMD3 $DEBUG_REDIRECT

                START_CMD3_STAT=$?
                msg "START_CMD3_STAT: $START_CMD3_STAT"

                msg "$START_CMD_STAT $START_CMD2_STAT $START_CMD3_STAT"

                if [ $START_CMD_STAT -eq 0 ] && [ $START_CMD2_STAT -eq 0 ] && [ $START_CMD3_STAT -eq 0 ]

                then
                             msg "Weblogic Started successfuly"
				msg "Setting EXIT_CODE=0"
                                EXIT_CODE=0

                else
                             msg "Weblogic Failed to start"
				msg "Setting EXIT_CODE=255"
                             EXIT_CODE=255
            fi

        else
            msg "Start is not allowed"
		msg "Setting EXIT_CODE=255"
            EXIT_CODE=255
    fi



}

stop()
{

    if [ "$SHUT_MS" == "TRUE" ]
        then

                msg "Stopping Managed Servers..."

            cat > /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd1.sh << EOF

#!/bin/bash
$STOP_CMD1

EOF

            chmod +x /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd1.sh
		STOP_CMD1_TIME_COUNTER_START=`date +%s`
            if [ "${TIMEOUT_CMD}x" != "x" ]
                then
                        $TIMEOUT_CMD $STOP_TIMEOUT /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd1.sh -s KILL
                else
                    /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd1.sh
            fi
		STOP_CMD1_TIME_COUNTER_FINISH=`date +%s`
		STOP_CMD1_TIME_ELAPSED=`echo "$STOP_CMD1_TIME_COUNTER_FINISH - $STOP_CMD1_TIME_COUNTER_START" | bc`
		msg "Stopped Managed Servers, time elapsed: $STOP_CMD1_TIME_ELAPSED sec"


    fi


        msg "Stopping NodeManager..."
	STOP_CMD2_TIME_COUNTER_START=`date +%s`
        eval $STOP_CMD2 $DEBUG_REDIRECT
	STOP_CMD2_TIME_COUNTER_FINISH=`date +%s`
	STOP_CMD2_TIME_ELAPSED=`echo "$STOP_CMD2_TIME_COUNTER_FINISH - $STOP_CMD2_TIME_COUNTER_START" | bc`
	msg "Stopped NodeManager, time elapsed: $STOP_CMD2_TIME_ELAPSED sec"

        echo "Stopping AdminServer..."

    cat > /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd3.sh << EOF

#!/bin/bash
$STOP_CMD3

EOF

    chmod +x /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd3.sh
    if [ "${TIMEOUT_CMD}x" != "x" ]
        then
                $TIMEOUT_CMD $STOP_TIMEOUT /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd3.sh -s KILL
        else
            /tmp/${WLS_USER}.${MY_DOMAIN_NAME}.${USER}.wls_stop_cmd3.sh
    fi

        msg "Wait for 10 seconds for stopping"
        sleep 10

    if [ "$CHECK_AFTER_STOP" == "YES" ]
        then
                PS_COUNT=`eval $PCMD | wc -l`
                if [ $PS_COUNT -gt 0 ]
                        then
                    msg "Some processes wont stop, kill them"
                    eval $STOP_CMD4 $DEBUG_REDIRECT
            fi
    fi

        echo "Weblogic stoppped successfuly"
    echo "Removing lock files..."
    rm -rf $WLS_LOCK_FILES
        EXIT_CODE=0

}

function partial_stop
{

        echo "Stopping NodeManager..."
        eval $STOP_CMD2

        echo "Wait for 10 seconds for stopping"
        sleep 10

        PS_COUNT=` eval $PCMD_NM | wc -l`
        if [ $PS_COUNT -gt 0 ]
                then
                        echo "Some process wont stop, kill them"
                        eval "$STOP_CMD2 -9"
        fi
    echo "Removing lock files..."
    rm -rf $WLS_LOCK_FILES
}

function status
{

if [ "$CHECK_SRV" == "YES" ]

    then
        echo "Checking Managed Servers..."
        eval $STATUS_SRV_CMD
        SRV_STATUS=$?
    else
        echo "Managed Servers check not enabled"
        SRV_STATUS=0
fi

if [ "$CHECK_APP" == "YES" ]
    then
        echo "Checking Applications..."
        eval $STATUS_APP_CMD
        APP_STAUS=$?
    else
        echo "Applications check not enabled"
        APP_STAUS=0
fi


if [ $SRV_STATUS -eq 0 ] && [ $APP_STAUS -eq 0 ]
        then
                echo "Status: OK"
                EXIT_CODE=0
        else
                echo "Status: Failed"
        echo "Managed servers status: $SRV_STATUS"
        echo "Applications status: $APP_STAUS"
        ### To be compatible with Veritas Cluster
                EXIT_CODE=100
fi



}


function status_app_zbx
{

    echo "Checking Applications..."
    eval $STATUS_APP_CMD_ZBX
}







function reset
{

eval $RESET_DS_CMD
RESET_STATUS=$?

if [ $RESET_STATUS -eq 0 ]
        then
                echo "Reset: OK"
                EXIT_CODE=0
        else
                echo "Reset: Failed"
                EXIT_CODE=255
fi

}

function start_ms_create
{

    if [ "$MNG_PARALLEL" == "TRUE" ]
        then
            MNG_START_CMD="start(Name, block='false');"
            START_MS_IMPORT="import time as systime"
            START_MS_SLEEP="systime.sleep(3);"
        else
            MNG_START_CMD="start(Name);"
    fi


    cat > ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.startManagedServersMany.py << EOF

import sys
${START_MS_IMPORT}

#Info for Connect()
usernameValue='weblogic';
passValue='weblogic1';
hostValue='127.0.0.1'; #Host name (Listen Address) of the Node Manager
portValue='7001'; #Port number of Node Manager

print 'Invoking ${MY_DOMAIN_NAME}.startManagedServersMany.py script';

try:

   #Attempt to connect to Node Manager. If fail to connect, start Node Manager.
      print 'Connecting to Adminserver.';
      #connect (usernameValue, passValue, 't3://%s:%s' %(hostValue,portValue) );
      connect(userConfigFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE}', userKeyFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE}', url='t3://${ADMIN_HOST}:${ADMIN_PORT}', timeout='${T3_TIMEOUT}');

   #Determine if WLST is currently connected to Node Manager on machine

      domainConfig();

      servers = cmo.getServers()
      serverNames = ([x.name for x in servers])

      domainRuntime();
      cd('/ServerLifeCycleRuntimes/');

      for Name in serverNames:
        if Name == 'AdminServer':
           print 'Skipping server: ' + Name;
           continue
        cd(Name);
        serverStatus = cmo.getState();
        print Name + ': ' + serverStatus;

        if not serverStatus == 'RUNNING':
           cd('/ServerLifeCycleRuntimes/');
           cd(Name);
           ${MNG_START_CMD}
           ${START_MS_SLEEP}
           serverStatus = cmo.getState();
           print 'New Server ' + Name + ' Status:' + serverStatus;

        cd('..')


finally:
     #Disconnect from Node Manager on OIM machine
     disconnect();
     exit();

print 'End startServers.py script';

EOF

chown $WLS_USER ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.startManagedServersMany.py

}

function stop_ms_create
{

    cat > ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.stopManagedServersMany.py << EOF

import sys

#Info for Connect()
usernameValue='weblogic';
passValue='weblogic1';
hostValue='127.0.0.1'; #Host name (Listen Address) of the Node Manager
portValue='7001'; #Port number of Node Manager

print 'Invoking ${MY_DOMAIN_NAME}.stopManagedServersMany.py script';

try:

   #Attempt to connect to Node Manager. If fail to connect, start Node Manager.
      print 'Connecting to Adminserver.';
      #connect (usernameValue, passValue, 't3://%s:%s' %(hostValue,portValue) );
      connect(userConfigFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE}', userKeyFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE}', url='t3://${ADMIN_HOST}:${ADMIN_PORT}', timeout='${T3_TIMEOUT}');

   #Determine if WLST is currently connected to Node Manager on machine

      domainConfig();

      servers = cmo.getServers()
      serverNames = ([x.name for x in servers])

      domainRuntime();
      cd('/ServerLifeCycleRuntimes/');

      for Name in serverNames:
        if Name == 'AdminServer':
           print 'Skipping server: ' + Name;
           continue
        cd(Name);
        serverStatus = cmo.getState();
        print Name + ': ' + serverStatus;

        if serverStatus == 'RUNNING':
           cd('/ServerLifeCycleRuntimes/');
           cd(Name);
           shutdown(Name,'Server','true',300,'true');
           serverStatus = cmo.getState();
           print 'New Server ' + Name + ' Status:' + serverStatus;

        cd('..')


finally:
     #Disconnect from Node Manager on OIM machine
     disconnect();
     exit();

print 'End startServers.py script';

EOF

chown $WLS_USER ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.stopManagedServersMany.py

}

function status_ms_create
{

    cat > ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusManagedServers.py << EOF

import sys

#Info for Connect()
usernameValue='weblogic';
passValue='weblogic1';
hostValue='127.0.0.1'; #Host name (Listen Address) of the Node Manager
portValue='7001'; #Port number of Node Manager

print 'Invoking ${MY_DOMAIN_NAME}.statusManagedServers.py script';

try:

   #Attempt to connect to Node Manager. If fail to connect, start Node Manager.
      print 'Connecting to Adminserver.';
      #connect (usernameValue, passValue, 't3://%s:%s' %(hostValue,portValue) );
      connect(userConfigFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE}', userKeyFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE}', url='t3://${ADMIN_HOST}:${ADMIN_PORT}', timeout='${T3_TIMEOUT}');

   #Determine if WLST is currently connected to Node Manager on machine

      domainConfig();

      servers = cmo.getServers()
      serverNames = ([x.name for x in servers])
      NumOfServers = len(serverNames)

      domainRuntime();
      cd('/ServerLifeCycleRuntimes/');

      print '-----------------------------------------------------------'
      print 'Found servers in domain: '
      print NumOfServers
      print '-----------------------------------------------------------'

      RunningServers = 0

      for Name in serverNames:
        cd(Name);
        serverStatus = cmo.getState();
        print Name + ': ' + serverStatus;
        if serverStatus == 'RUNNING':
          RunningServers = RunningServers + 1
        cd('..')

      print '-----------------------------------------------------------'
      print 'Running servers in domain: '
      print RunningServers
      print '-----------------------------------------------------------'

      if NumOfServers == RunningServers:
         print 'Status -> OK'
      else:
         print 'Status -> Failed'


finally:
     #Disconnect from Node Manager on OIM machine
     disconnect();
     exit();

print 'End ${MY_DOMAIN_NAME}.statusManagedServers.py script';


EOF

chown $WLS_USER ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusManagedServers.py

}

function status_app_create
{

    cat > ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusApp.py << EOF

print 'Invoking ${MY_DOMAIN_NAME}.statusApp.py script';

try:
  #connect('weblogic','weblogic1','t3://127.0.0.1:7001');
  connect(userConfigFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE}', userKeyFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE}', url='t3://${ADMIN_HOST}:${ADMIN_PORT}', timeout='${T3_TIMEOUT}');

  cd ('AppDeployments')
  myapps=cmo.getAppDeployments()

  RunningApps = 0
  NumOfApps = 0

  for appName in myapps:
    domainConfig()
    cd ('/AppDeployments/'+appName.getName()+'/Targets')
    redirect('/dev/null','false')
    mytargets = ls(returnMap='true',returnType='c')
    redirect('/dev/null','true')
    domainRuntime()
    cd('AppRuntimeStateRuntime')
    cd('AppRuntimeStateRuntime')
    for targetinst in mytargets:
      NumOfApps = NumOfApps + 1
      curstate4=cmo.getCurrentState(appName.getName(),targetinst)
      if curstate4 == 'STATE_ACTIVE':
        RunningApps = RunningApps + 1
      print '%s ---> %s' % (appName.getName(),  curstate4)
      print '$PREFIX%s:%s' % (appName.getName(),  curstate4)


  #NumOfApps = len(myapps)

  print 'Total Applications: %s' % (NumOfApps)
  print 'Running  Applications: %s' % (RunningApps)

  if NumOfApps == RunningApps:
    print 'Status -> OK'
  else:
    print 'Status -> Failed'

finally:
  disconnect();
  exit();

print 'End ${MY_DOMAIN_NAME}.statusApp.py script';

EOF

chown $WLS_USER ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.statusApp.py

}

function reset_ds_create
{

    cat > ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.resetDS.py << EOF

#connect('weblogic','weblogic1','t3://127.0.0.1:7001');
connect(userConfigFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_CONF_FILE}', userKeyFile='${HOME_FOLDER}/${SCRIPTS_FOLDER}/${USER_KEY_FILE}', url='t3://${ADMIN_HOST}:${ADMIN_PORT}', timeout='${T3_TIMEOUT}');
allServers=domainRuntimeService.getServerRuntimes();
for tempServer in allServers:
  tempServerName = tempServer.getName()
  jdbcServiceRT = tempServer.getJDBCServiceRuntime();
  dataSources = jdbcServiceRT.getJDBCDataSourceRuntimeMBeans();
  if (len(dataSources) > 0):
    print 'Server:', tempServerName
    for dataSource in dataSources:
      DS_Name = dataSource.getName()
      DS_State = dataSource.getState()
      print DS_Name, ':', DS_State

      if DS_State == 'Suspended':
        domainRuntime()
        cd ('ServerRuntimes/'+tempServerName+'/JDBCServiceRuntime/'+tempServerName+'/JDBCDataSourceRuntimeMBeans/'+DS_Name);
        objArray = jarray.array([], java.lang.Object)
        strArray = jarray.array([], java.lang.String)
        invoke('reset', objArray, strArray);
        DS_New_State = dataSource.getState()
        print 'New State:', DS_New_State

      else:
        if DS_State == 'Shutdown':
          domainRuntime()
          cd ('ServerRuntimes/'+tempServerName+'/JDBCServiceRuntime/'+tempServerName+'/JDBCDataSourceRuntimeMBeans/'+DS_Name);
          objArray = jarray.array([], java.lang.Object)
          strArray = jarray.array([], java.lang.String)
          invoke('start', objArray, strArray);
          DS_New_State = dataSource.getState()
          print 'New State:', DS_New_State

EOF

chown $WLS_USER ${HOME_FOLDER}/${SCRIPTS_FOLDER}/${MY_DOMAIN_NAME}.resetDS.py


}

add_vip_addr() {

        if [ $USE_VIP == YES ]
                then
                        echo "Adding Virtual IP address"
                        eval $ADD_VIP
                        sleep 2
                        echo "Pinging Default Gateway"
                        eval $PING_GW
                        sleep 2
                        echo "Sending gratious ARP"
                        eval $PING_ARP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}

remove_vip_addr() {
        if [ $USE_VIP == YES ]
                then
                        echo "Deleting Virtual IP address"
                        eval $DEL_VIP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}

function print_commands {

    echo "List of Weblogic Porcesses (PCMD):"
    echo $PCMD
    echo "List of Weblogic NodeManager processes (PCMD_NM):"
    echo $PCMD_NM

    echo "Add Virtual IP Address:"
    echo $ADD_VIP
    echo "Delete Virtial IP Address:"
    echo $DEL_VIP
    echo $PING_GW
    echo $PING_ARP

    echo $START_CMD
    echo $START_CMD2
    echo $START_CMD3

    echo $STOP_CMD1
    echo "Stop Node Manager command (STOP_CMD2):"
    echo $STOP_CMD2
    echo $STOP_CMD3
    echo "Kill all command (STOP_CMD4):"
    echo $STOP_CMD4

    echo $STATUS_APP_CMD
    echo $STATUS_SRV_CMD

    echo $RESET_DS_CMD

    echo $TIMEOUT_CMD

    echo $SHUT_LOG_CMD


}


#Create jython scripts
start_ms_create
stop_ms_create
status_ms_create
status_app_create
reset_ds_create



case "$1" in
    start)
        msg "===== Executing script with START option"
        if [ "$UNAME" == "Linux" ] && [ $LINUX_RELEASE -lt 7 ]
            then
                touch /var/lock/subsys/wls${WLS_VERSION}
        fi
        create_lock_file
        add_vip_addr
        start
        remove_lock_file
    ;;

    stop)
        msg "===== Executing script with STOP option"
        create_lock_file
            stop
        remove_vip_addr
        remove_lock_file
        eval $SHUT_LOG_CMD

    ;;

    status)
        msg "===== Executing script with STATUS option"
        status
    ;;

    status_app_zbx)
                status_app_zbx
        ;;


    reset)
        msg "===== Executing script with RESET option"
        create_lock_file
        reset
        remove_lock_file
    ;;

    add_vip)
        msg "===== Executing script with ADD_VIP option"
        create_lock_file
        add_vip_addr
        remove_lock_file
    ;;

    del_vip)
        msg "===== Executing script with DEL_VIP option"
        create_lock_file
        remove_vip_addr
        remove_lock_file
    ;;
    print)
        print_commands
    ;;
    print_mw_home)
        echo "print_mw_home:$MY_MW_HOME"
    ;;


    *)
        echo "Usage: $0 {start|stop|status|status_app_zbx|reset|add_vip|del_vip|print|print_mw_home}"
        EXIT_CODE=255
esac

rm -f ${LOG_FOLDER}/wlst_*
msg "Exiting with EXIT_CODE=$EXIT_CODE"
exit $EXIT_CODE
